<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.7"/>
<title>TI  Graph Library   (TIGL): TIGLComputationManager&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt; Class Template Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/search.js"></script>
<script type="text/javascript">
  $(document).ready(function() { searchBox.OnSelectItem(0); });
</script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td style="padding-left: 0.5em;">
   <div id="projectname">TI  Graph Library   (TIGL)
   &#160;<span id="projectnumber">ver1.00.00</span>
   </div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.7 -->
<script type="text/javascript">
var searchBox = new SearchBox("searchBox", "search",false,'Search');
</script>
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li>
        <div id="MSearchBox" class="MSearchBoxInactive">
        <span class="left">
          <img id="MSearchSelect" src="search/mag_sel.png"
               onmouseover="return searchBox.OnSearchSelectShow()"
               onmouseout="return searchBox.OnSearchSelectHide()"
               alt=""/>
          <input type="text" id="MSearchField" value="Search" accesskey="S"
               onfocus="searchBox.OnSearchFieldFocus(true)" 
               onblur="searchBox.OnSearchFieldFocus(false)" 
               onkeyup="searchBox.OnSearchFieldChange(event)"/>
          </span><span class="right">
            <a id="MSearchClose" href="javascript:searchBox.CloseResultsWindow()"><img id="MSearchCloseImg" border="0" src="search/close.png" alt=""/></a>
          </span>
        </div>
      </li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="hierarchy.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
<a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(0)"><span class="SelectionMark">&#160;</span>All</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(1)"><span class="SelectionMark">&#160;</span>Classes</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(2)"><span class="SelectionMark">&#160;</span>Files</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(3)"><span class="SelectionMark">&#160;</span>Functions</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(4)"><span class="SelectionMark">&#160;</span>Variables</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(5)"><span class="SelectionMark">&#160;</span>Enumerations</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(6)"><span class="SelectionMark">&#160;</span>Groups</a><a class="SelectItem" href="javascript:void(0)" onclick="searchBox.OnSelectItem(7)"><span class="SelectionMark">&#160;</span>Pages</a></div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a> &#124;
<a href="classTIGLComputationManager-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">TIGLComputationManager&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt; Class Template Reference<div class="ingroups"><a class="el" href="group__comp__engine.html">Computation Engine</a></div></div>  </div>
</div><!--header-->
<div class="contents">

<p>Core Computation class for the TIGL.  
 <a href="classTIGLComputationManager.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="tiglComputationManager_8hpp_source.html">tiglComputationManager.hpp</a>&gt;</code></p>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:a879099d2e308b25450cc7d1d3016ca4f"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a879099d2e308b25450cc7d1d3016ca4f">TIGLComputationManager</a> ()</td></tr>
<tr class="memdesc:a879099d2e308b25450cc7d1d3016ca4f"><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a879099d2e308b25450cc7d1d3016ca4f">More...</a><br /></td></tr>
<tr class="separator:a879099d2e308b25450cc7d1d3016ca4f"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aba8d4744970ec2a5e8297a00f10cac41"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aba8d4744970ec2a5e8297a00f10cac41"></a>
&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#aba8d4744970ec2a5e8297a00f10cac41">~TIGLComputationManager</a> ()</td></tr>
<tr class="memdesc:aba8d4744970ec2a5e8297a00f10cac41"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destructor. <br /></td></tr>
<tr class="separator:aba8d4744970ec2a5e8297a00f10cac41"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a62094a2a7cc365e474911c8cdcf2f42d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a62094a2a7cc365e474911c8cdcf2f42d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a62094a2a7cc365e474911c8cdcf2f42d">reset</a> ()</td></tr>
<tr class="memdesc:a62094a2a7cc365e474911c8cdcf2f42d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Resets the compute engine to return to the state before algorithm execution. <br /></td></tr>
<tr class="separator:a62094a2a7cc365e474911c8cdcf2f42d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a89e5b0d303c95bb327f5448cb0cdafb4"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a89e5b0d303c95bb327f5448cb0cdafb4">setDataManager</a> (SUBGRAPH_CLASS *dm)</td></tr>
<tr class="memdesc:a89e5b0d303c95bb327f5448cb0cdafb4"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the data manager pointer.  <a href="#a89e5b0d303c95bb327f5448cb0cdafb4">More...</a><br /></td></tr>
<tr class="separator:a89e5b0d303c95bb327f5448cb0cdafb4"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a57ed006bd76d3ebabc95783c1d720e98"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a57ed006bd76d3ebabc95783c1d720e98">setCombiner</a> (COMBINER_TYPE *cmb)</td></tr>
<tr class="memdesc:a57ed006bd76d3ebabc95783c1d720e98"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the combiner pointer.  <a href="#a57ed006bd76d3ebabc95783c1d720e98">More...</a><br /></td></tr>
<tr class="separator:a57ed006bd76d3ebabc95783c1d720e98"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a0c19b25315f8617bf955c57ba585708c"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a0c19b25315f8617bf955c57ba585708c">isInitialized</a> ()</td></tr>
<tr class="memdesc:a0c19b25315f8617bf955c57ba585708c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Checks if the object is properly initialized.  <a href="#a0c19b25315f8617bf955c57ba585708c">More...</a><br /></td></tr>
<tr class="separator:a0c19b25315f8617bf955c57ba585708c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9b2333c170951b5c20e9989431f07061"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a9b2333c170951b5c20e9989431f07061">setMaxSS</a> (uint_fast32_t maxSSVal)</td></tr>
<tr class="memdesc:a9b2333c170951b5c20e9989431f07061"><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the maximum number of supersteps.  <a href="#a9b2333c170951b5c20e9989431f07061">More...</a><br /></td></tr>
<tr class="separator:a9b2333c170951b5c20e9989431f07061"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a63e04e8ed34a164d431bff438f0820d9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a63e04e8ed34a164d431bff438f0820d9">processSystemMessages</a> (uint_fast32_t countSS)</td></tr>
<tr class="memdesc:a63e04e8ed34a164d431bff438f0820d9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Processes all system messages.  <a href="#a63e04e8ed34a164d431bff438f0820d9">More...</a><br /></td></tr>
<tr class="separator:a63e04e8ed34a164d431bff438f0820d9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ad6620bad7b93a884ac61d8b9dbad72c9"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#ad6620bad7b93a884ac61d8b9dbad72c9">init</a> (INIT_TYPE *initParams)</td></tr>
<tr class="memdesc:ad6620bad7b93a884ac61d8b9dbad72c9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialization procedure.  <a href="#ad6620bad7b93a884ac61d8b9dbad72c9">More...</a><br /></td></tr>
<tr class="separator:ad6620bad7b93a884ac61d8b9dbad72c9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a13e218d765c0f7d3ae0364ce9bcac100"><td class="memItemLeft" align="right" valign="top">SS_STATUS&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a13e218d765c0f7d3ae0364ce9bcac100">superstep</a> (uint_fast32_t countSS)</td></tr>
<tr class="memdesc:a13e218d765c0f7d3ae0364ce9bcac100"><td class="mdescLeft">&#160;</td><td class="mdescRight">Core superstep computation procedure.  <a href="#a13e218d765c0f7d3ae0364ce9bcac100">More...</a><br /></td></tr>
<tr class="separator:a13e218d765c0f7d3ae0364ce9bcac100"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3a49c653fe10ede53342578eb8b629a7"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3a49c653fe10ede53342578eb8b629a7"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a3a49c653fe10ede53342578eb8b629a7">getNumExternalMessages</a> ()</td></tr>
<tr class="memdesc:a3a49c653fe10ede53342578eb8b629a7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of output message. <br /></td></tr>
<tr class="separator:a3a49c653fe10ede53342578eb8b629a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a183e121a76fbf583ae1361115528a2a5"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a183e121a76fbf583ae1361115528a2a5"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a183e121a76fbf583ae1361115528a2a5">getPastNumExternalMessages</a> ()</td></tr>
<tr class="memdesc:a183e121a76fbf583ae1361115528a2a5"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of output message in the previous superstep. <br /></td></tr>
<tr class="separator:a183e121a76fbf583ae1361115528a2a5"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab834aa5a7c594f48b54945ea8c1bcd53"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ab834aa5a7c594f48b54945ea8c1bcd53"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#ab834aa5a7c594f48b54945ea8c1bcd53">numActive</a> ()</td></tr>
<tr class="memdesc:ab834aa5a7c594f48b54945ea8c1bcd53"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of active nodes for the device. <br /></td></tr>
<tr class="separator:ab834aa5a7c594f48b54945ea8c1bcd53"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aaed2a0a1e69e54490fdf19a682333100"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aaed2a0a1e69e54490fdf19a682333100"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#aaed2a0a1e69e54490fdf19a682333100">getNumIdleSysMessages</a> ()</td></tr>
<tr class="memdesc:aaed2a0a1e69e54490fdf19a682333100"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of received idle system messages. <br /></td></tr>
<tr class="separator:aaed2a0a1e69e54490fdf19a682333100"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aee548a331e88ce34fca4ca44b6542a7d"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="aee548a331e88ce34fca4ca44b6542a7d"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#aee548a331e88ce34fca4ca44b6542a7d">pushHaltMessage</a> ()</td></tr>
<tr class="memdesc:aee548a331e88ce34fca4ca44b6542a7d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Pushes a halt message into the sys message buffer. <br /></td></tr>
<tr class="separator:aee548a331e88ce34fca4ca44b6542a7d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4ae39e3f2c0ce1f75683a600cb5bf0e3"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4ae39e3f2c0ce1f75683a600cb5bf0e3"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a4ae39e3f2c0ce1f75683a600cb5bf0e3">getNumHaltSysMessages</a> ()</td></tr>
<tr class="memdesc:a4ae39e3f2c0ce1f75683a600cb5bf0e3"><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of received halt system messages. <br /></td></tr>
<tr class="separator:a4ae39e3f2c0ce1f75683a600cb5bf0e3"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr class="memitem:a24ea788379f2e180e2f409ca2c41393e"><td class="memTemplParams" colspan="2">template&lt;typename ALLOCATOR_TYPE &gt; </td></tr>
<tr class="memitem:a24ea788379f2e180e2f409ca2c41393e"><td class="memTemplItemLeft" align="right" valign="top">void&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a24ea788379f2e180e2f409ca2c41393e">distributeOutMessages</a> (vector&lt; MESSAGE_TYPE, ALLOCATOR_TYPE &gt; *outMessages, uint_fast32_t countSS, int thread)</td></tr>
<tr class="memdesc:a24ea788379f2e180e2f409ca2c41393e"><td class="mdescLeft">&#160;</td><td class="mdescRight">Distributes messages after node execution @ details It processes the output messages after each node processing and route them to appropriate internal or external message buffer.  <a href="#a24ea788379f2e180e2f409ca2c41393e">More...</a><br /></td></tr>
<tr class="separator:a24ea788379f2e180e2f409ca2c41393e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:aca32d884b684440682dfcc9544f23da7"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#aca32d884b684440682dfcc9544f23da7">combineMessages</a> (bool oddTimeFlag)</td></tr>
<tr class="memdesc:aca32d884b684440682dfcc9544f23da7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Combines all the messages.  <a href="#aca32d884b684440682dfcc9544f23da7">More...</a><br /></td></tr>
<tr class="separator:aca32d884b684440682dfcc9544f23da7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ada263bbea0c5f663e3325d0cfe649a95"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="ada263bbea0c5f663e3325d0cfe649a95"></a>
void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#ada263bbea0c5f663e3325d0cfe649a95">clearActiveBuffers</a> ()</td></tr>
<tr class="memdesc:ada263bbea0c5f663e3325d0cfe649a95"><td class="mdescLeft">&#160;</td><td class="mdescRight">Clears the active buffer (this is called for each new superstep) <br /></td></tr>
<tr class="separator:ada263bbea0c5f663e3325d0cfe649a95"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a640b3d21343c751076499f91cf9ec84c"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a640b3d21343c751076499f91cf9ec84c">InsertActive</a> (uint_fast32_t *allPos, uint_fast16_t count)</td></tr>
<tr class="memdesc:a640b3d21343c751076499f91cf9ec84c"><td class="mdescLeft">&#160;</td><td class="mdescRight">Inserts new vertices in the local active list.  <a href="#a640b3d21343c751076499f91cf9ec84c">More...</a><br /></td></tr>
<tr class="separator:a640b3d21343c751076499f91cf9ec84c"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ab048be6d511aaa45746a471c75135a5d"><td class="memTemplParams" colspan="2">template&lt;typename ALLOCATOR_TYPE &gt; </td></tr>
<tr class="memitem:ab048be6d511aaa45746a471c75135a5d"><td class="memTemplItemLeft" align="right" valign="top">uint_fast32_t&#160;</td><td class="memTemplItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#ab048be6d511aaa45746a471c75135a5d">executeVertex</a> (VERTEX_ITERATOR itVertex, uint_fast32_t pos, bool oddTimeFlag, vector&lt; MESSAGE_TYPE, ALLOCATOR_TYPE &gt; *outMessages)</td></tr>
<tr class="memdesc:ab048be6d511aaa45746a471c75135a5d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Executes a single vertex during a super step.  <a href="#ab048be6d511aaa45746a471c75135a5d">More...</a><br /></td></tr>
<tr class="separator:ab048be6d511aaa45746a471c75135a5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr class="memitem:a35980108d459ef20496179326a7eeff0"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a35980108d459ef20496179326a7eeff0"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a35980108d459ef20496179326a7eeff0">maxSS</a></td></tr>
<tr class="memdesc:a35980108d459ef20496179326a7eeff0"><td class="mdescLeft">&#160;</td><td class="mdescRight">holds the number of supersteps and the maximum number <br /></td></tr>
<tr class="separator:a35980108d459ef20496179326a7eeff0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a636f467a499bd29d9151e3dd012c8194"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a636f467a499bd29d9151e3dd012c8194"></a>
vector&lt; uint_fast32_t &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a636f467a499bd29d9151e3dd012c8194">activeList</a></td></tr>
<tr class="memdesc:a636f467a499bd29d9151e3dd012c8194"><td class="mdescLeft">&#160;</td><td class="mdescRight">holds the ID of the active vertex list <br /></td></tr>
<tr class="separator:a636f467a499bd29d9151e3dd012c8194"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3acf15a44b963c38fac7fe053499fd81"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a3acf15a44b963c38fac7fe053499fd81"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a3acf15a44b963c38fac7fe053499fd81">numLocalActive</a></td></tr>
<tr class="memdesc:a3acf15a44b963c38fac7fe053499fd81"><td class="mdescLeft">&#160;</td><td class="mdescRight">number of active vertices on the current device <br /></td></tr>
<tr class="separator:a3acf15a44b963c38fac7fe053499fd81"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a1ea6f01329ffaa968914dbf802febb6e"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a1ea6f01329ffaa968914dbf802febb6e"></a>
bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a1ea6f01329ffaa968914dbf802febb6e">allActive</a></td></tr>
<tr class="memdesc:a1ea6f01329ffaa968914dbf802febb6e"><td class="mdescLeft">&#160;</td><td class="mdescRight">if enabled: all vertices are active all the time (terminated by max count) <br /></td></tr>
<tr class="separator:a1ea6f01329ffaa968914dbf802febb6e"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a6a468af9d43aacf4c047b60d59549dfe"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a6a468af9d43aacf4c047b60d59549dfe"></a>
<a class="el" href="classTIGLContainersAggregate.html">TIGLContainersAggregate</a><br class="typebreak" />
&lt; ALG_DATA_TYPE &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a6a468af9d43aacf4c047b60d59549dfe">aggregateInfo</a></td></tr>
<tr class="memdesc:a6a468af9d43aacf4c047b60d59549dfe"><td class="mdescLeft">&#160;</td><td class="mdescRight">the aggregate information object <br /></td></tr>
<tr class="separator:a6a468af9d43aacf4c047b60d59549dfe"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a9a1d7cc592962f35c0b009f44b52beac"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a9a1d7cc592962f35c0b009f44b52beac"></a>
SUBGRAPH_CLASS *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a9a1d7cc592962f35c0b009f44b52beac">dataManager</a></td></tr>
<tr class="memdesc:a9a1d7cc592962f35c0b009f44b52beac"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the data manager object <br /></td></tr>
<tr class="separator:a9a1d7cc592962f35c0b009f44b52beac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a56931bcd432a1b5bfdb51e66c0c5aa86"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a56931bcd432a1b5bfdb51e66c0c5aa86"></a>
COMBINER_TYPE *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a56931bcd432a1b5bfdb51e66c0c5aa86">combiner</a></td></tr>
<tr class="memdesc:a56931bcd432a1b5bfdb51e66c0c5aa86"><td class="mdescLeft">&#160;</td><td class="mdescRight">pointer to the data combiner object <br /></td></tr>
<tr class="separator:a56931bcd432a1b5bfdb51e66c0c5aa86"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af1ac42b93564a6a2925bc7229ade4f40"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="af1ac42b93564a6a2925bc7229ade4f40"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#af1ac42b93564a6a2925bc7229ade4f40">numIdleSysMessages</a></td></tr>
<tr class="memdesc:af1ac42b93564a6a2925bc7229ade4f40"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of idle system messages that are received. <br /></td></tr>
<tr class="separator:af1ac42b93564a6a2925bc7229ade4f40"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4e749987615a77add6a44801fb35b591"><td class="memItemLeft" align="right" valign="top"><a class="anchor" id="a4e749987615a77add6a44801fb35b591"></a>
uint_fast32_t&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classTIGLComputationManager.html#a4e749987615a77add6a44801fb35b591">numHaltSysMessages</a></td></tr>
<tr class="memdesc:a4e749987615a77add6a44801fb35b591"><td class="mdescLeft">&#160;</td><td class="mdescRight">The number of halt system messages that are received. <br /></td></tr>
<tr class="separator:a4e749987615a77add6a44801fb35b591"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><h3>template&lt;typename SUBGRAPH_CLASS, typename COMBINER_TYPE, typename INIT_TYPE&gt;<br />
class TIGLComputationManager&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;</h3>

<p>Core Computation class for the TIGL. </p>
<p>It handles all the superstep processing including: vertex processing, message combining, aggregate information updating, and message distribution. it also handles the initialization procedure for all vertices. It is a template class that is parameterized by the following parameters </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">SUBGRAPH_CLASS</td><td>the data manager class definition, </td></tr>
    <tr><td class="paramname">COMBINER_TYPE</td><td>the data combiner class definition, </td></tr>
    <tr><td class="paramname">INIT_TYPE</td><td>the definition of the init parameters of the graph algorithm</td></tr>
  </table>
  </dd>
</dl>
<p>@ date October 2, 2014 @ author Texas Instruments</p>
<p>Revision History:<br />
05/1/2014: created for single device support <br />
08/20/2014: added basic MPI functionality <br />
10/02/2014: completed MPI support including system messaging, and message buffers <br />
</p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a879099d2e308b25450cc7d1d3016ca4f"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::<a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Constructor. </p>
<p>Resets counters and flags </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a class="anchor" id="aca32d884b684440682dfcc9544f23da7"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::combineMessages </td>
          <td>(</td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>oddTimeFlag</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Combines all the messages. </p>
<p>This is called at the beginning of the superstep to combine all local and external messages for each vertex Each omp thread has its own message buffer, while external messages has its own buffer. They are all combined to thread 0 buffer. The function also sets all the local active nodes (depending on their messages). </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">oddTimeFlag</td><td>flag for the ping-poing buffer: true for odd superstep, false for even superstep </td></tr>
  </table>
  </dd>
</dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Iterate over all local vertices (with multiple threads)</li>
<li>If the vertex is not active and cannot be reactivated, move to the next vertex.</li>
<li>Iterate over all message buffers for the current vertex (which equals the number of omp threads + 1 (if MPI is enabled) ).</li>
<li>Combine messages in the current message buffer of the current vertex.</li>
<li>Add the combined messages to the end of the message buffer 0 for the current vertex.</li>
<li>Clear the current message buffer (if it is not buffer 0).</li>
<li>Combine all messages at message buffer 0 for the current vertex.</li>
<li>If the current vertex has messages, add to active vertex list. </li>
</ol>

</div>
</div>
<a class="anchor" id="a24ea788379f2e180e2f409ca2c41393e"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename ALLOCATOR_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::distributeOutMessages </td>
          <td>(</td>
          <td class="paramtype">vector&lt; MESSAGE_TYPE, ALLOCATOR_TYPE &gt; *&#160;</td>
          <td class="paramname"><em>outMessages</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>countSS</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>thread</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Distributes messages after node execution @ details It processes the output messages after each node processing and route them to appropriate internal or external message buffer. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">outMessages</td><td>a buffer of messeages after a single vertex execution </td></tr>
    <tr><td class="paramname">countSS</td><td>the Superstep count </td></tr>
    <tr><td class="paramname">thread</td><td>current omp thread </td></tr>
  </table>
  </dd>
</dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Iterate over all new messages.</li>
<li>Get the ID of the destination vertex.</li>
<li>If the destination is an external vertex, push the message to the external message buffer.</li>
<li>Else push the message to the local message buffer of the destination vertex. </li>
</ol>

</div>
</div>
<a class="anchor" id="ab048be6d511aaa45746a471c75135a5d"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<div class="memtemplate">
template&lt;typename ALLOCATOR_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">uint_fast32_t <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::executeVertex </td>
          <td>(</td>
          <td class="paramtype">VERTEX_ITERATOR&#160;</td>
          <td class="paramname"><em>itVertex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>pos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">bool&#160;</td>
          <td class="paramname"><em>oddTimeFlag</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">vector&lt; MESSAGE_TYPE, ALLOCATOR_TYPE &gt; *&#160;</td>
          <td class="paramname"><em>outMessages</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Executes a single vertex during a super step. </p>
<p>It reads the input messages and calls the compute function of the vertex </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">itVertex</td><td>iterator to the current vertex in the vertex list </td></tr>
    <tr><td class="paramname">pos</td><td>position of the vartex (used for messages retrieval) </td></tr>
    <tr><td class="paramname">oddTimeFlag</td><td>flag for the ping-poing buffer: true for odd SS, false for even S </td></tr>
    <tr><td class="paramname">outMessages</td><td>buffers for the output messages after vertex execution</td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>the number of output messages </dd></dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Get message handler.</li>
<li>Call the customized <a class="el" href="classTIGLApiVertex.html#a509bac1afaa2f2141616ae8fc06c0ddd">compute</a> function for the graph algorithm</li>
<li>Clear input message buffer </li>
</ol>

</div>
</div>
<a class="anchor" id="ad6620bad7b93a884ac61d8b9dbad72c9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::init </td>
          <td>(</td>
          <td class="paramtype">INIT_TYPE *&#160;</td>
          <td class="paramname"><em>initParams</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Initialization procedure. </p>
<p>It is called once for each algorithm before executing the supersteps and it calls the customized <a class="el" href="classTIGLApiVertex.html#a846155817024d5eb7c732a3989b639f1">init</a> function for all vertices on the device. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">initParams</td><td>pointer to the initialization parameter of the graph algorithm </td></tr>
  </table>
  </dd>
</dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Clear active buffers.</li>
<li>Clear external message buffers.</li>
<li>Iterate over all local vertices.</li>
<li>For each vertex, call the customized <a class="el" href="classTIGLApiVertex.html#a846155817024d5eb7c732a3989b639f1">init</a> function for the graph algorithm.</li>
<li>Distribute the output messages to local and external message buffers by calling <a class="el" href="classTIGLComputationManager.html#a24ea788379f2e180e2f409ca2c41393e">distributeOutMessages</a>.</li>
<li>update local aggregate information.</li>
<li>end of vertex iteration.</li>
<li>Update global aggregate information.</li>
<li>Prepare aggregate information system messages and push to external message buffer.</li>
<li>If all nodes are not active, send a system IDLE message </li>
</ol>

</div>
</div>
<a class="anchor" id="a640b3d21343c751076499f91cf9ec84c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::InsertActive </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t *&#160;</td>
          <td class="paramname"><em>allPos</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">uint_fast16_t&#160;</td>
          <td class="paramname"><em>count</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">protected</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Inserts new vertices in the local active list. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">allPos</td><td>pointer to the buffer that contains the new vertices </td></tr>
    <tr><td class="paramname">count</td><td>number of vertices in the input buffer </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a0c19b25315f8617bf955c57ba585708c"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">bool <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::isInitialized </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Checks if the object is properly initialized. </p>
<dl class="section return"><dt>Returns</dt><dd>true if initialized, false otherwise </dd></dl>

</div>
</div>
<a class="anchor" id="a63e04e8ed34a164d431bff438f0820d9"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::processSystemMessages </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>countSS</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Processes all system messages. </p>
<p>This function is executed at each superstep before processing data messages. </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">countSS</td><td>the current SS index. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a57ed006bd76d3ebabc95783c1d720e98"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::setCombiner </td>
          <td>(</td>
          <td class="paramtype">COMBINER_TYPE *&#160;</td>
          <td class="paramname"><em>cmb</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the combiner pointer. </p>
<p>This function has to be called before running graph algorithms </p><dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">cmb</td><td>pointer to the data combiner object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a89e5b0d303c95bb327f5448cb0cdafb4"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::setDataManager </td>
          <td>(</td>
          <td class="paramtype">SUBGRAPH_CLASS *&#160;</td>
          <td class="paramname"><em>dm</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the data manager pointer. </p>
<p>This function has to be called before running graph algorithms</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">dm</td><td>pointer to the data manager object </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a9b2333c170951b5c20e9989431f07061"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::setMaxSS </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>maxSSVal</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Sets the maximum number of supersteps. </p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">maxSSVal</td><td>maximum possible number of supersteps </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a13e218d765c0f7d3ae0364ce9bcac100"></a>
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;typename SUBGRAPH_CLASS , typename COMBINER_TYPE , typename INIT_TYPE &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">SS_STATUS <a class="el" href="classTIGLComputationManager.html">TIGLComputationManager</a>&lt; SUBGRAPH_CLASS, COMBINER_TYPE, INIT_TYPE &gt;::superstep </td>
          <td>(</td>
          <td class="paramtype">uint_fast32_t&#160;</td>
          <td class="paramname"><em>countSS</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Core superstep computation procedure. </p>
<p>It processes both system and data messages and route the output message to the appropriate buffers it also call the (algorithm-dependent) combiner function after processing all input messages</p>
<dl class="params"><dt>Parameters</dt><dd>
  <table class="params">
    <tr><td class="paramname">countSS</td><td>the current SS index </td></tr>
  </table>
  </dd>
</dl>
<dl class="section return"><dt>Returns</dt><dd>The execution status, possible values are: SS_SUCCESS, NOT_INITIALIZED, VERTEX_NOT_FOUND, ALGORITHM_COMPLETED, MAX_SS_REACHED, </dd></dl>
<p><b>Procedure</b> </p><ol type="1">
<li>Combine all local and external message for each vertx using <a class="el" href="classTIGLComputationManager.html#aca32d884b684440682dfcc9544f23da7">combineMessages </a></li>
<li>Reset aggregate information</li>
<li>Process system messages</li>
<li>Iterate over all active nodes (mutlithread execution); execute the following steps for each active vertex</li>
<li>Retrieve the vertex position</li>
<li>Execute the vertex (using <a class="el" href="classTIGLComputationManager.html#ab048be6d511aaa45746a471c75135a5d">executeVertex</a>).</li>
<li>Update the aggregate information for the current vertex.</li>
<li>Distribute the output messages from executing the current vertex to appropriate message buffers using <a class="el" href="classTIGLComputationManager.html#a24ea788379f2e180e2f409ca2c41393e">distributeOutMessages</a></li>
<li>End of the active vertex loop</li>
<li>Update global aggregate information, and prepare system aggregate message.</li>
<li>If there is no active nodes, send system IDLE message to all devices. </li>
</ol>

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li><a class="el" href="tiglComputationManager_8hpp_source.html">tiglComputationManager.hpp</a></li>
<li><a class="el" href="tiglComputationManagerImplementation_8hpp_source.html">tiglComputationManagerImplementation.hpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated on Thu Jun 25 2015 11:13:56 for TI  Graph Library   (TIGL) by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.7
</small></address>
</body>
</html>
